import React, { Component } from "react";
import logo from "./logo.svg";
import "./App.css";

import Count from "../components/counter";
import Button from "../components/button";
import List from "../components/list";

class App extends Component {
	constructor(props) {
		super(props);
		this.state = {
			count: 0,
			value: "",
			posts: [],
			showPosts: false
		};

		this.test = this.test.bind(this);
		console.log("its constuctor");
	}

	showButton = () => this.setState({ showPosts: true });

	componentDidMount() {
		fetch("https://jsonplaceholder.typicode.com/posts")
			.then(response => response.json())
			.then(json => this.setState({ posts: json }));
	}

	test() {
		console.log("test");
	}

	increseCounter = () => this.setState(prevState => ({ count: prevState.count + 1 }));

	changeValue = e => this.setState({ value: e.target.value });

	render() {
		const { count, value, posts, showPosts } = this.state;
		return (
			<div className="App">
				<header className="App-header">
					<img src={logo} className="App-logo" alt="logo" />
					<p>
						Edit <code>src/App.js</code> and save to reload.
					</p>
					<a className="App-link" href="https://reactjs.org" target="_blank" rel="noopener noreferrer">
						Learn React {value}
					</a>
					<Count count={count} />
					<Button text="CLICK MEEEE" onClick={this.increseCounter} />
					<Button text="SHOW POSTS" onClick={this.showButton} />
					<input type="text" value={value} onChange={e => this.changeValue(e)} />
				</header>
				{showPosts ? (
					<ul>
						{posts.map(el => (
							<List key={el.id} id={el.id} title={el.title} />
						))}
					</ul>
				) : (
					<div>NOT KOMLETE YET</div>
				)}
			</div>
		);
	}
}

export default App;
